'This is the top-level object (parent)
' It initializes ChildA and ChildB
' Both are children of this object.  ChildB will also create a reference to ChildA.
' After initializing ChildA with a value, we will initialize ChildB.
' Parent's ChildB will then look at ChildA's value - it should read the same
' as what we initialized it to be from this parent object.

  _xinfreq      = 5_000_000          'Set crystal frequency to 5 MHz
  _clkmode      = xtal1 + pll16x     'wind it up to 80 MHz via a X16 PLL

OBJ
  objChildA     : "ChildA"
  objChildB     : "ChildB"

  
PUB Start | ChildAValue

  'Init LEDs to be outputs
  DirA[16..23] := %11111111

  
  'Initialize Child A with a pattern and start Child B
  objChildA.Start(%10101010)
  objChildB.Start
  
  'Now we'll read Child A's value and display it on the LEDs - it should be the pattern above.
  ChildAValue := objChildA.ReadValue
  
  OutA[16..23] := ChildAValue
  waitcnt(300_000_000+cnt)

  
  'Set all LEDs to on so that if Child B reads zero, they will turn off.
  OutA[16..23] := %11111111
  waitcnt(300_000_000+cnt)
  
  'Now read Child B's perception of Child A's value - it should be the same pattern above.
  ChildAValue := objChildB.ReadValue

  OutA[16..23] := ChildAValue
  waitcnt(300_000_000+cnt)

  'Well? What happened?
  